import "reflect-metadata";
import ContainerOptions = interfaces.ContainerOptions;
import { Container, interfaces } from "inversify";
import { App, StaticServiceProvider } from "./index";
export declare abstract class Bundle {
    abstract readonly name: string;
    protected readonly containerConfiguration: ContainerOptions;
    protected readonly heartbeatInterval: number;
    protected readonly serviceProviders: StaticServiceProvider[];
    private _container;
    private logger;
    private loadedServiceProviders;
    private apps;
    private booted;
    readonly container: Container;
    readonly workingApps: App[];
    readonly longRunning: boolean;
    constructor();
    boot(): Promise<void>;
    run(): Promise<void>;
    bootChild(): Promise<Container>;
    stop(): Promise<void>;
    protected loadServiceProviders(): void;
    protected bootContainer(): void;
    protected bootServiceProviders(): Promise<void>;
    protected bootLogging(): Promise<void>;
    protected buildApps(): void;
    protected startHeartbeat(): Promise<{}>;
    protected tick(timer: any, complete: () => void): void;
    protected runApps(): Promise<void>;
    protected runApp(app: App): Promise<void>;
}
