"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("./Data/Authorization/Bearer");
require("./Data/Authorization/Oauth2");
var lodash_1 = __importDefault(require("lodash"));
var mitt_1 = __importDefault(require("mitt"));
var ServiceProvider_1 = require("./ServiceProvider");
var App_1 = require("./App");
var Symbols_1 = require("./Symbols");
var ApiConnections_1 = require("./Data/ApiConnections");
var ProtocultureServiceProvider = (function (_super) {
    __extends(ProtocultureServiceProvider, _super);
    function ProtocultureServiceProvider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ProtocultureServiceProvider.prototype.boot = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.makeInjectable(App_1.BaseApp);
                this.bundle.container.bind(Symbols_1.protocultureSymbols.Bundle)
                    .toConstantValue(this.bundle);
                this.configureEventBusDispatcher();
                this.configureApiConnections();
                return [2];
            });
        });
    };
    ProtocultureServiceProvider.prototype.configureEventBusDispatcher = function () {
        var _this = this;
        var eventBus = new mitt_1.default();
        eventBus.on("*", (function (type, event) {
            var eventKey = "protoculture.event." + type;
            if (_this.bundle.container.isBound(eventKey)) {
                var eventMethod_1 = lodash_1.default.camelCase("" + type);
                _this.bundle.container
                    .getAll(eventKey)
                    .forEach(function (handler) {
                    return handler[eventMethod_1](event);
                });
            }
        }));
        this.bundle.container
            .bind(Symbols_1.protocultureSymbols.EventBus)
            .toConstantValue(eventBus);
    };
    ProtocultureServiceProvider.prototype.configureApiConnections = function () {
        this.makeInjectable(ApiConnections_1.ApiConnections);
        this.bindConstructor(Symbols_1.protocultureSymbols.ApiConnections, ApiConnections_1.ApiConnections);
        this.bindConstructorParameter([Symbols_1.protocultureSymbols.ApiConfiguration], ApiConnections_1.ApiConnections, 0);
    };
    return ProtocultureServiceProvider;
}(ServiceProvider_1.ServiceProvider));
exports.ProtocultureServiceProvider = ProtocultureServiceProvider;
//# sourceMappingURL=ProtocultureServiceProvider.js.map