import { Context } from "inversify/dts/planning/context";
import { Container, interfaces } from "inversify";
import { Bundle, App, ConnectionConfiguration } from "./index";
import { ConnectionConfigurations } from "./Data/ApiConnections";
interface AppConstructor<AppType extends App> {
    new (...args: any[]): AppType;
}
export interface StaticServiceProvider {
    new (bundle: Bundle): ServiceProvider;
}
export declare abstract class ServiceProvider {
    bundle: Bundle;
    constructor(bundle: Bundle);
    boot(): Promise<void>;
    bootChild(container: Container): Promise<void>;
    protected configureEventHandler(event: string, symbol: symbol): void;
    protected configureEventHandler(event: string, handler: {
        new (): any;
    }, injections: symbol[]): void;
    protected configureApiConnection(factory: ((context: Context) => Partial<ConnectionConfigurations>)): interfaces.BindingWhenOnSyntax<{}>;
    protected configureApiConnection(name: string, configuration: Partial<ConnectionConfiguration<any>>): interfaces.BindingWhenOnSyntax<{}>;
    protected bindApp<AppType extends AppConstructor<any>>(app: AppType): interfaces.BindingWhenOnSyntax<AppType>;
    protected makeInjectable(object: any): void;
    protected bindConstructor<Type>(symbol: symbol | string, staticType: {
        new (...args: any[]): Type;
    }): interfaces.BindingWhenOnSyntax<Type>;
    protected bindConstructorParameter(symbol: symbol | symbol[], staticType: any, position: number, tag?: string): void;
}
export {};
