"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = __importDefault(require("lodash"));
var inversify_1 = require("inversify");
var index_1 = require("./index");
var ServiceProvider = (function () {
    function ServiceProvider(bundle) {
        this.bundle = bundle;
    }
    ServiceProvider.prototype.boot = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2];
            });
        });
    };
    ServiceProvider.prototype.bootChild = function (container) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2];
            });
        });
    };
    ServiceProvider.prototype.configureEventHandler = function (event, handlerOrSymbol, injections) {
        var _this = this;
        if (injections === void 0) { injections = []; }
        var eventKey = "protoculture.event." + event;
        if (lodash_1.default.isSymbol(handlerOrSymbol)) {
            var symbol = handlerOrSymbol;
            this.bundle.container.bind(eventKey).toService(symbol);
        }
        else {
            var handler_1 = handlerOrSymbol;
            this.makeInjectable(handler_1);
            this.bindConstructor(eventKey, handler_1);
            injections.forEach(function (injection, index) {
                return _this.bindConstructorParameter(injection, handler_1, index);
            });
        }
    };
    ServiceProvider.prototype.configureApiConnection = function (configurationOrFactoryOrName, configurationOrFactory) {
        var _a;
        var name = lodash_1.default.isString(configurationOrFactoryOrName)
            ? configurationOrFactoryOrName
            : "";
        var configuration = configurationOrFactory || configurationOrFactoryOrName;
        var binding = this.bundle.container.bind(index_1.protocultureSymbols.ApiConfiguration);
        return lodash_1.default.isFunction(configuration)
            ? binding.toDynamicValue(configuration)
            : binding.toConstantValue((_a = {},
                _a[name] = configuration,
                _a));
    };
    ServiceProvider.prototype.bindApp = function (app) {
        this.makeInjectable(app);
        return this.bindConstructor(index_1.protocultureSymbols.App, app);
    };
    ServiceProvider.prototype.makeInjectable = function (object) {
        inversify_1.decorate(inversify_1.injectable(), object);
    };
    ServiceProvider.prototype.bindConstructor = function (symbol, staticType) {
        return this.bundle.container.bind(symbol)
            .to(staticType)
            .inSingletonScope();
    };
    ServiceProvider.prototype.bindConstructorParameter = function (symbol, staticType, position, tag) {
        if (tag === void 0) { tag = null; }
        if (lodash_1.default.isArray(symbol)) {
            inversify_1.decorate(inversify_1.multiInject(symbol[0]), staticType, position);
        }
        else {
            inversify_1.decorate(inversify_1.inject(symbol), staticType, position);
        }
    };
    return ServiceProvider;
}());
exports.ServiceProvider = ServiceProvider;
//# sourceMappingURL=ServiceProvider.js.map